
//
// Academic License - for use in teaching, academic research, and meeting
// course requirements at degree granting institutions only.  Not for
// government, commercial, or other organizational use.
// File: kin_xyzbc_tt_forward.cpp
//
// MATLAB Coder version            : 5.4
//

// Include Files
#include "kin_xyzbc_tt_forward.h"
#include "coder_array.h"
#include <cmath>

// Function Definitions
//
// function piece = kin_xyzbc_tt_forward(in1,in2)
//
// KIN_XYZBC_TT_FORWARD
//     PIECE = KIN_XYZBC_TT_FORWARD(IN1,IN2)
//
// Arguments    : const ::coder::array<double, 1U> &in1
//                const ::coder::array<double, 1U> &in2
//                double piece[5]
// Return Type  : void
//
namespace ocn {
void kin_xyzbc_tt_forward(const ::coder::array<double, 1U> &in1,
                          const ::coder::array<double, 1U> &in2, double piece[5])
{
    double t10;
    double t11;
    double t2;
    double t3;
    double t4;
    double t5;
    double t9;
    //     This function was generated by the Symbolic Math Toolbox version 9.1.
    //     07-Nov-2023 14:54:33
    // Forward Kinematics :
    // INPUTS :
    // 	r_j    (5x1) : pose vector( joint space )
    // 	p      (3x5) : parameters
    // OUTPUTS :
    // 	r_t    (5x1) : pose vector ( piece frame )
    // 'kin_xyzbc_tt_forward:15' b = in1(4,:);
    // 'kin_xyzbc_tt_forward:16' c = in1(5,:);
    // 'kin_xyzbc_tt_forward:17' offB1 = in2(10);
    // 'kin_xyzbc_tt_forward:18' offB2 = in2(11);
    // 'kin_xyzbc_tt_forward:19' offC1 = in2(13);
    // 'kin_xyzbc_tt_forward:20' offB3 = in2(12);
    // 'kin_xyzbc_tt_forward:21' offC2 = in2(14);
    // 'kin_xyzbc_tt_forward:22' offC3 = in2(15);
    // 'kin_xyzbc_tt_forward:23' offM1 = in2(1);
    // 'kin_xyzbc_tt_forward:24' offM2 = in2(2);
    // 'kin_xyzbc_tt_forward:25' offM3 = in2(3);
    // 'kin_xyzbc_tt_forward:26' offP1 = in2(7);
    // 'kin_xyzbc_tt_forward:27' offP2 = in2(8);
    // 'kin_xyzbc_tt_forward:28' offP3 = in2(9);
    // 'kin_xyzbc_tt_forward:29' offT1 = in2(4);
    // 'kin_xyzbc_tt_forward:30' offT2 = in2(5);
    // 'kin_xyzbc_tt_forward:31' offT3 = in2(6);
    // 'kin_xyzbc_tt_forward:32' x = in1(1,:);
    // 'kin_xyzbc_tt_forward:33' y = in1(2,:);
    // 'kin_xyzbc_tt_forward:34' z = in1(3,:);
    // 'kin_xyzbc_tt_forward:35' t2 = cos(b);
    t2 = std::cos(in1[3]);
    // 'kin_xyzbc_tt_forward:36' t3 = cos(c);
    t3 = std::cos(in1[4]);
    // 'kin_xyzbc_tt_forward:37' t4 = sin(b);
    t4 = std::sin(in1[3]);
    // 'kin_xyzbc_tt_forward:38' t5 = sin(c);
    t5 = std::sin(in1[4]);
    // 'kin_xyzbc_tt_forward:39' t6 = -offM1;
    // 'kin_xyzbc_tt_forward:40' t7 = -offM2;
    // 'kin_xyzbc_tt_forward:41' t8 = -offM3;
    // 'kin_xyzbc_tt_forward:42' t9 = offB1+offC1+offT1+t6+x;
    t9 = (((in2[9] + in2[12]) + in2[3]) + -in2[0]) + in1[0];
    // 'kin_xyzbc_tt_forward:43' t10 = offB2+offC2+offT2+t7+y;
    t10 = (((in2[10] + in2[13]) + in2[4]) + -in2[1]) + in1[1];
    // 'kin_xyzbc_tt_forward:44' t11 = offB3+offC3+offT3+t8+z;
    t11 = (((in2[11] + in2[14]) + in2[5]) + -in2[2]) + in1[2];
    // 'kin_xyzbc_tt_forward:45' piece =
    // [-offC1-offP1-offB1.*t3-offB2.*t5+t5.*t10+t2.*t3.*t9-t3.*t4.*t11;-offC2-offP2-offB2.*t3+offB1.*t5+t3.*t10-t2.*t5.*t9+t4.*t5.*t11;-offB3-offC3-offP3+t2.*t11+t4.*t9;b;c];
    piece[0] = (((((-in2[12] - in2[6]) - in2[9] * t3) - in2[10] * t5) + t5 * t10) + t2 * t3 * t9) -
               t3 * t4 * t11;
    piece[1] = (((((-in2[13] - in2[7]) - in2[10] * t3) + in2[9] * t5) + t3 * t10) - t2 * t5 * t9) +
               t4 * t5 * t11;
    piece[2] = (((-in2[11] - in2[14]) - in2[8]) + t2 * t11) + t4 * t9;
    piece[3] = in1[3];
    piece[4] = in1[4];
}

} // namespace ocn

//
// File trailer for kin_xyzbc_tt_forward.cpp
//
// [EOF]
//
